#include <errno.h>
#include <fcntl.h>
#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <sys/param.h>

//hara
#include<string.h> 

/* XXXX: tricky definitions */
#define UTDS_DO_GARBAGE_CLEAR

#include "../include/u3tdsio.h"
#include "../include/u3tdssdh.h"
#include "examples.h"

#define TIME_CHECK

#define MAX_FILE_SIZE		(1 * 1024 * 1024 * 1024 /* 1Gbyte */)
#define DEFAULT_BLOCK_SIZE	(64 * 1024 /* 64kbyte */)
//#define DEFAULT_DEVFILE		"/dev/tds0"
#define DEFAULT_DEVFILE		"/dev/u3tds0"

static char *progName;

#define LINE_LENGTH_MAX 7 // ԤĹξ
#define DAT_NUM_MAX 128     // ǡξ

struct tdsauxiol {
	int auxsize;
	char auxfield[500];
};
typedef struct tdsauxiol *tdsauxiol_t;


static void usage(void);
static void
usage()
{
	fprintf(stderr, "usage: %s "
	    "[-C channes] [-F filter] [-N number] [-a auxfile]\n"
	    "usage: %s "
	    "[-C channes] [-F filter] [-g gain]\n",
	    progName,progName);
//	fprintf(stderr, "       type : is defined 9260, 9270\n");
	exit(EXIT_FAILURE);
}


//tdsio_regio_t iocmd;

int main(int argc, char **argv)
{
	mode_t ofilemode = S_IRUSR | S_IWUSR | S_IRGRP | S_IROTH;
	struct tdsauxiol sdhin, sdhout;
	struct tdsio tdsio;
	uint32_t samplingRate, samplingFilter, samplingWidth, samplingChannels;
	uint32_t status, tdstime, tdserrno, version;
	uint8_t sampling;
	int samplingVerbose, samplingCount, samplingBlock, syncpattern;
	int fd_in, fd_out, fd_aux, opt, fileno, rv, dc, i, initflag;
#ifdef  TIME_CHECK
	int checkTimeSync = 0;
#endif
	unsigned char dcoff[4];
	char *devfile, *outfile, *auxfile, *type, *buf;
	extern int optind;
	extern char *optarg;
struct tdsio_regio iocmd;
int ii;
char line[LINE_LENGTH_MAX]; 
unsigned short values[DAT_NUM_MAX];
unsigned short chan,filn,datanum,gain=0;
unsigned int n,nflag,gflag=0;
FILE *fp;
	samplingRate = TDSIO_SAMPLING_16MHZ;
	samplingFilter = TDSIO_SAMPLING_THRU;
	samplingWidth = TDSIO_SAMPLING_8BIT;
	samplingChannels = TDSIO_SAMPLING_1CH;
	samplingVerbose = 0;
	samplingCount = -1;
	samplingBlock = DEFAULT_BLOCK_SIZE;
	fileno = 0;
	dc = 0;
	devfile = DEFAULT_DEVFILE;
	outfile = NULL;
	auxfile = NULL;
	type = "";
	initflag = 0;
	memset(&sdhin, 0, sizeof (struct tdsauxiol));
	memset(&sdhout, 0, sizeof (struct tdsauxiol));



	/* ޥɹԥץβ */
	progName = argv[0];
	while((opt = getopt(argc, argv, "C:IF:N:a:g:")) != EOF) {
		switch(opt) {
		case 'C':	/* number of channel */
//			samplingChannels = get_channels(optarg);
			chan = strtol(optarg, NULL, 0);
			break;
//		case 'F':	/* number of channel */
//			samplingFilter = get_filter(optarg);
//			break;
		case 'I':	/* must initialize */
			initflag = 1;
			break;
		case 'F':	/* number of filter */
			filn = strtol(optarg, NULL, 0);
			filn -= 1;
			break;
//#ifdef  TIME_CHECK
//		case 'T':
//			checkTimeSync = 1;
//			syncpattern = (int)strtoul(optarg, NULL, 0);
//			break;
//#endif
		case 'N':	/* number of data */
			datanum = strtol(optarg, NULL, 0);
			nflag=1;
			break;
		case 'a':	/* file */
			auxfile = optarg;
			break;
		case 'g':	/* gain */
			gain = strtol(optarg, NULL, 0);
			gflag=1;
			break;
//		case 'b':	/* read block size */
//			samplingBlock = (int)strtoul(optarg, NULL, 0);
//			break;
//		case 'd':	/* DCoffset */
//			dcoff[dc++] = (int)strtoul(optarg, NULL, 0);
//			break;
//		case 'i':	/* input device */
//			devfile = optarg;
//			break;
//		case 'n':	/* repeat count */
//			samplingCount = (int)strtol(optarg, NULL, 0);
//			break;
//		case 'o':	/* output file */
//			outfile = optarg;
//			break;
//		case 't':	/* board type */
//			for (i = 0; typetbl[i] != NULL; i ++)
//				if (strcmp(optarg, typetbl[i]) == 0)
//					break;
//			if (typetbl[i] == NULL)
//				usage();
//			type = typetbl[i];
//			break;
//		case 'v':	/* verbose mode */
//			samplingVerbose = 1;
//			break;
		case '?':
		default:
			usage();
		}
	}
	if(gflag)
		if(nflag)
			usage();

	/* ǥХΥץ */
//printf("device open\n");
	if ((fd_in = open(devfile, O_RDONLY)) == -1) {
		perror("device open() error ");
		return -1;
	}
	if ((rv = ioctl(fd_in, TDSIO_GET_VERSION, &version)) < 0)
		perror("ioctl() version get failed ");
	else
		printf("%s: driver version: %d.%d.%d\n",
		    devfile, TDS_VERSION_MAJOR(version),
		    TDS_VERSION_MINOR(version), TDS_VERSION_REVISION(version));

	if ((rv = ioctl(fd_in, TDSIO_GET_STATUS, &status)) < 0)
		perror("ioctl() status get failed ");
	else
		printf("current status: 0x%02x\n", status);

	if ((rv = ioctl(fd_in, TDSIO_INIT)) == -1) {
		perror("ioctl() init failed ");
		goto end;
	} else
		printf("ioctl() init succeed\n");
	sleep(3);

	if(gflag){
		iocmd.address=(unsigned short)((chan&0x07)<<8 | (filn&0x01)<<7 | (filn?0x7f:0x3f));
		iocmd.value=(unsigned char)gain;
printf("ADCREG set:0x%04x,0x%02x", iocmd.address,gain);
		if ((rv = ioctl(fd_in, TDSIO_SET_ADC, &iocmd)) != 0) {
			perror("sample.c:ioctl() ADCREG set failed ");
printf("%d\n", rv);
			goto end;
		}
		iocmd.address=(unsigned short)((chan&0x07)<<8 | (filn&0x01)<<7 | (filn?0x7f:0x3f));
		if ((rv = ioctl(fd_in, TDSIO_GET_ADC, &iocmd)) < 0) {
			perror("sample.c: ioctl() REGIO read failed");
printf("sample.c err: REGIO read: %d %d\n", iocmd.value, rv);
			goto end;
		}
printf(" get:0x%04x,%02x\n", iocmd.address, iocmd.value);
		goto end;
	}


	if(!(fp = fopen(auxfile, "r"))){
		return 1;
	}
	n = 0;
	while(fgets(line, LINE_LENGTH_MAX, fp))	{
//		values[n] = (unsigned char)strtol(line, NULL, 10);
		values[n] = (unsigned short)strtol(line, NULL, 10);
//		values[n] = atol(line);
printf("%02x\n", values[n]);
		n++;
	}
	fclose(fp);


	if (datanum > n){
		printf ("auxtest:Assigned datanumber greater than linenum. so, datanumber change to linenum.");
		datanum = n+1;
	}
	if (chan > 4)	chan -= 4;

printf("chan:%d filn:%d datanum:%d \n",chan,filn,datanum);
printf("chan:%04x filn:%04x datanum:%d \n",chan<<8,filn<<7,datanum);

	for(n=0;n<datanum;n++){
		iocmd.address=(unsigned short)((chan&0x07)<<8 | (filn&0x01)<<7 | (n&0x7f));
		iocmd.value=(unsigned char)values[n];
printf("ADCREG set:0x%04x,0x%02x", iocmd.address,values[n]);
		if ((rv = ioctl(fd_in, TDSIO_SET_ADC, &iocmd)) != 0) {
			perror("sample.c:ioctl() ADCREG set failed ");
printf("%d\n", rv);
			goto end;
		}
		iocmd.address=(unsigned short)((chan&0x07)<<8 | (filn&0x01)<<7 | (n&0x7f));
//		iocmd.address=chan<<8|filn<<7|n;
		if ((rv = ioctl(fd_in, TDSIO_GET_ADC, &iocmd)) < 0) {
			perror("sample.c: ioctl() REGIO read failed");
printf("sample.c err: REGIO read: %d %d\n", iocmd.value, rv);
			goto end;
		}
printf(" get:0x%04x,%02x\n", iocmd.address, iocmd.value);
	}

goto end;

 end:
	/* ϥեΥ */
	close(fd_out);
	/* ǥХΥ */
	close(fd_in);

	return rv;
}
